require "import"
import "android.widget.*"
import "android.view.*"
import "android.app.*"
import "android.os.*"

activity.setTitle("رحلة البنزين الكبرى")

layout = {
  LinearLayout,
  orientation = "vertical",
  padding = "16dp",
  {
    TextView,
    id = "locationText",
    textSize = "18sp",
  },
  {
    TextView,
    id = "descText",
    textSize = "14sp",
  },
  {
    TextView,
    id = "distanceText",
    textSize = "14sp",
  },
  {
    Button,
    id = "walkButton",
    text = "اضغط واستمر للمشي",
    layout_marginTop = "10dp",
  },
  {
    TextView,
    id = "kmCounter",
    text = "عدد الكيلومترات: 0 كم",
    textSize = "16sp",
  },
  {
    TextView,
    id = "coinCounter",
    text = "العملات: 0",
    textSize = "16sp",
  },
  {
    TextView,
    id = "fuelLevel",
    text = "نسبة البنزين: 100%",
    textSize = "16sp",
  },
  {
    Button,
    id = "refuelButton",
    text = "تعبئة البنزين (50 عملة)",
    layout_marginTop = "10dp",
  },
  {
    TextView,
    id = "endText",
    text = "",
    visibility = View.GONE,
    textSize = "14sp",
    layout_marginTop = "16dp",
  },
  {
    Button,
    id = "retryButton",
    text = "إعادة المحاولة",
    visibility = View.GONE,
    layout_marginTop = "10dp",
  },
  {
    Button,
    id = "exitButton",
    text = "خروج",
    visibility = View.GONE,
    layout_marginTop = "10dp",
  },
}

activity.setContentView(loadlayout(layout))

-- المواقع
locations = {
  {name="شارع الزيتون", desc="شارع هادئ بأشجار الزيتون.", dist=2.5},
  {name="وادي الديناصور", desc="يقال إن ديناصوراً كان يعيش هنا.", dist=3.2},
  {name="جبل الفشار", desc="كل من يصعده يشتهي فشاراً.", dist=2.0},
  {name="قرية التنانين", desc="هنا يُربى التنانين الصغيرة.", dist=2.8},
  {name="شاطئ الحمم", desc="ماءه ساخن كأنك في قدر طبخ!", dist=3.5},
  {name="غابة العلكة", desc="كل الأشجار تطلع علكة بطعم النعناع.", dist=2.3},
  {name="مدينة النعاس", desc="يمنع الدخول لمن لا يشعر بالنعاس.", dist=1.9},
  {name="نفق الهروب الكبير", desc="كل الطرق تؤدي إلى... متاهة!", dist=2.6},
  {name="مزرعة الموز الطائر", desc="الموز هنا يطير فعلاً!", dist=3.1},
  {name="شارع أبو الغاز", desc="من أقوى الشوارع في الرياح الخلفية.", dist=2.7},
  {name="ميدان المشاوي", desc="ريحة المشويات تصدح بالمكان.", dist=2.4},
  {name="ساحة الصراخ", desc="كل من يمر يصرخ تلقائيًا!", dist=3.0},
  {name="جسر العسل", desc="أرضيته مصنوعة من العسل الصلب.", dist=2.2},
  {name="سوق الباندا", desc="تبيع دببة الباندا كل شيء!", dist=2.9},
  {name="سجن المهرجين", desc="أغرب سجن، الكل يضحك فيه.", dist=3.3},
  {name="مخبأ الساحر زغلول", desc="يُقال أن زغلول لم يُهزم أبداً.", dist=2.1},
  {name="كوكب البطاطا", desc="كل شيء مصنوع من البطاطا!", dist=3.4},
  {name="نهر البيبسي", desc="لا تشرب كثير، غازاته قوية.", dist=2.6},
  {name="تل النمل العملاق", desc="نمل بحجم الكلاب يعيش هنا.", dist=2.5},
  {name="حديقة النكت البايخة", desc="ضحكك مضمون حتى لو مجامل.", dist=2.8},
  {name="قصر النعامة الذهبية", desc="أسطورة النعامة التي لا تخاف.", dist=3.0},
}

-- عدادات
km = 0
coins = 0
fuel = 100
current = 1
running = false

-- تحديث الواجهة
function updateUI()
  local loc = locations[current]
  locationText.setText("الموقع: " .. loc.name)
  descText.setText(loc.desc)
  distanceText.setText("المتبقي: " .. string.format("%.1f", loc.dist) .. " كم")
  kmCounter.setText("عدد الكيلومترات: " .. string.format("%.1f", km) .. " كم")
  coinCounter.setText("العملات: " .. coins)
  fuelLevel.setText("نسبة البنزين: " .. fuel .. "%")
end

handler = Handler()
walkRunnable = Runnable{
  run = function()
    if running and fuel > 0 then
      local loc = locations[current]
      km = km + 0.1
      coins = coins + 1
      fuel = fuel - 2
      loc.dist = loc.dist - 0.1
      if loc.dist <= 0 then
        coins = coins + 20
        fuel = math.min(100, fuel + 34)
        current = current + 1
        if current > #locations then
          endText.setText("مبروك! تم اجتياز كل المواقع!\nتحياتي من تطوير أخوكم مهند التقني.")
          endText.setVisibility(View.VISIBLE)
          exitButton.setVisibility(View.VISIBLE)
          walkButton.setEnabled(false)
        else
          Toast.makeText(activity, "مبروك! اجتزت الموقع!", 1).show()
        end
      end
      updateUI()
      handler.postDelayed(walkRunnable, 300)
    elseif fuel <= 0 then
      running = false
      walkButton.setEnabled(false)
      endText.setText("للأسف لقد خسرت!\nأدري انت سايق جيس حب، دير بالك تصير سايق لا تبلينا!")
      endText.setVisibility(View.VISIBLE)
      retryButton.setVisibility(View.VISIBLE)
    end
  end
}

walkButton.setOnTouchListener{
  onTouch = function(v, e)
    if e.getAction() == MotionEvent.ACTION_DOWN then
      running = true
      handler.post(walkRunnable)
    elseif e.getAction() == MotionEvent.ACTION_UP then
      running = false
    end
    return true
  end
}

refuelButton.onClick = function()
  if coins >= 50 then
    coins = coins - 50
    fuel = 100
    updateUI()
  else
    Toast.makeText(activity, "لا تملك عملات كافية", 1).show()
  end
end

retryButton.onClick = function()
  locations[current].dist = 3.0 -- نعيد مسافة تقديرية
  fuel = 100
  retryButton.setVisibility(View.GONE)
  endText.setVisibility(View.GONE)
  walkButton.setEnabled(true)
  updateUI()
end

exitButton.onClick = function()
  activity.finish()
end

updateUI()